/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.storage.jooq.tables.ScriptParamDef;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ScriptParamDefRecord extends UpdatableRecordImpl<ScriptParamDefRecord> implements Record8<Long, Long, String, String, String, Boolean, String, byte[]> {

	private static final long serialVersionUID = -1724559142;

	/**
	 * Setter for <code>public.script_param_def.id</code>.
	 */
	public ScriptParamDefRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.script_param_def.script_def_id</code>.
	 */
	public ScriptParamDefRecord setScriptDefId(Long value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.script_def_id</code>.
	 */
	public Long getScriptDefId() {
		return (Long) getValue(1);
	}

	/**
	 * Setter for <code>public.script_param_def.name</code>.
	 */
	public ScriptParamDefRecord setName(String value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.name</code>.
	 */
	public String getName() {
		return (String) getValue(2);
	}

	/**
	 * Setter for <code>public.script_param_def.type</code>.
	 */
	public ScriptParamDefRecord setType(String value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.type</code>.
	 */
	public String getType() {
		return (String) getValue(3);
	}

	/**
	 * Setter for <code>public.script_param_def.description</code>.
	 */
	public ScriptParamDefRecord setDescription(String value) {
		setValue(4, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.description</code>.
	 */
	public String getDescription() {
		return (String) getValue(4);
	}

	/**
	 * Setter for <code>public.script_param_def.array</code>.
	 */
	public ScriptParamDefRecord setArray(Boolean value) {
		setValue(5, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.array</code>.
	 */
	public Boolean getArray() {
		return (Boolean) getValue(5);
	}

	/**
	 * Setter for <code>public.script_param_def.method</code>.
	 */
	public ScriptParamDefRecord setMethod(String value) {
		setValue(6, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.method</code>.
	 */
	public String getMethod() {
		return (String) getValue(6);
	}

	/**
	 * Setter for <code>public.script_param_def.default_value</code>.
	 */
	public ScriptParamDefRecord setDefaultValue(byte[] value) {
		setValue(7, value);
		return this;
	}

	/**
	 * Getter for <code>public.script_param_def.default_value</code>.
	 */
	public byte[] getDefaultValue() {
		return (byte[]) getValue(7);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record8 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row8<Long, Long, String, String, String, Boolean, String, byte[]> fieldsRow() {
		return (Row8) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row8<Long, Long, String, String, String, Boolean, String, byte[]> valuesRow() {
		return (Row8) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field2() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.SCRIPT_DEF_ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field3() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.NAME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field4() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.TYPE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field5() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.DESCRIPTION;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Boolean> field6() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.ARRAY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field7() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.METHOD;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<byte[]> field8() {
		return ScriptParamDef.SCRIPT_PARAM_DEF.DEFAULT_VALUE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value2() {
		return getScriptDefId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value3() {
		return getName();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value4() {
		return getType();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value5() {
		return getDescription();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Boolean value6() {
		return getArray();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value7() {
		return getMethod();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public byte[] value8() {
		return getDefaultValue();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value2(Long value) {
		setScriptDefId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value3(String value) {
		setName(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value4(String value) {
		setType(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value5(String value) {
		setDescription(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value6(Boolean value) {
		setArray(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value7(String value) {
		setMethod(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord value8(byte[] value) {
		setDefaultValue(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptParamDefRecord values(Long value1, Long value2, String value3, String value4, String value5, Boolean value6, String value7, byte[] value8) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		value5(value5);
		value6(value6);
		value7(value7);
		value8(value8);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached ScriptParamDefRecord
	 */
	public ScriptParamDefRecord() {
		super(ScriptParamDef.SCRIPT_PARAM_DEF);
	}

	/**
	 * Create a detached, initialised ScriptParamDefRecord
	 */
	public ScriptParamDefRecord(Long id, Long scriptDefId, String name, String type, String description, Boolean array, String method, byte[] defaultValue) {
		super(ScriptParamDef.SCRIPT_PARAM_DEF);

		setValue(0, id);
		setValue(1, scriptDefId);
		setValue(2, name);
		setValue(3, type);
		setValue(4, description);
		setValue(5, array);
		setValue(6, method);
		setValue(7, defaultValue);
	}
}
